#include <bits/stdc++.h>
using namespace std;
int n, x, y, z; int P[100096]; vector< vector <int> >D; map <int, int> m;
long long sol;
int main()
{
  scanf("%d", &n); D.resize(n+1);
  for(int i = 1; i <= n; i++)
    scanf("%d", &x), P[x]++;
  for(int i = 1; i <= n; i++)
    scanf("%d", &y), D[y].push_back(i);
  for(int i = 1; i <= n; i++)
    scanf("%d", &z), m[z]++;
  for(int i = 1; i <= n; i++)
  {
    int p = D[i].size();
    for(int j = 0; j < p; j++)
      sol += P[i] * m[D[i][j]];
  }
  printf("%lld\n", sol);


  return 0;
}